#include <QtGui/QApplication>
#include "qmlapplicationviewer.h"
#include "maskimageprovider.h"

Q_DECL_EXPORT int main(int argc, char *argv[])
{
    QScopedPointer<QApplication> app(createApplication(argc, argv));

    QmlApplicationViewer viewer;
    viewer.engine()->addImageProvider("mask", new MaskImageProvider());

    viewer.setOrientation(QmlApplicationViewer::ScreenOrientationAuto);
    viewer.setMainQmlFile(QLatin1String("qml/ImageMaskTester/main.qml"));
    viewer.showExpanded();

    return app->exec();
}
