#include <QtDeclarative>
#include <QDeclarativeImageProvider>
#include <iostream>

#include "maskimageprovider.h"


MaskImageProvider::MaskImageProvider()
    : QDeclarativeImageProvider(QDeclarativeImageProvider::Pixmap) {

    //    QString mask_path = QDir::currentPath() + "/qml/ImageMaskTester/icons/mask80.png";
    QString mask_path = "/opt/ImageMaskTester/qml/ImageMaskTester/icons/mask80.png";

    qDebug() << mask_path;
    m_mask = QImage(mask_path); // FIXME


}

/**
  * provide an cache name and orginal name separated by '|' symbol
  * e.g.
  * Image { source: "image://mask/./tempfile.png" }
  */


QPixmap MaskImageProvider::requestPixmap(const QString& id, QSize* size, const QSize& requestedSize) {
    QImage image = requestImage(id, size, requestedSize);
    QPixmap pixmap = QPixmap::fromImage(image);
    return pixmap;
}

QImage MaskImageProvider::requestImage(const QString &id, QSize *size, const QSize& requestedSize) {

    Q_UNUSED(requestedSize)

    if (m_mask.isNull()) {
        qDebug() << "Mask Image not found";
        return QImage();
    }

    //    QString imageFilename = QDir::currentPath() + "/" + id;
    QString imageFilename = "/opt/ImageMaskTester/" + id;
    qDebug() << imageFilename;

    QImage targetImage(80,80, QImage::Format_ARGB32);

    QImage tempImage(imageFilename);

    if (!tempImage.isNull()) {

        QImage sourceImage = tempImage.scaled(QSize(80,80)).convertToFormat(QImage::Format_ARGB32);
        qDebug() << sourceImage.isNull();

        for (int y = 0; y < sourceImage.height(); y++) {
            QRgb *target = (QRgb *)targetImage.scanLine(y);
            QRgb *source = (QRgb *)sourceImage.scanLine(y);
            QRgb *mask = (QRgb *)m_mask.scanLine(y);
            for (int x = 0; x < sourceImage.width(); x++) {
                *target = (*source & 0x00ffffff) | (((*mask & 0xff000000) >> 24) * ((*source & 0xff000000) >> 24) / 0xff) << 24;
                target++;
                source++;
                mask++;
            }
        }
/*
        for (int y = 0; y < scaled_mask.height(); y++ ) {
            for (int x = 0; x < scaled_mask.width(); x++ ) {
                QRgb mask_pixel = scaled_mask.pixel(x,y);
                QRgb image_pixel = result.pixel(x,y);

                image_pixel = qRgba(qRed(image_pixel), qGreen(image_pixel), qBlue(image_pixel), qAlpha(mask_pixel));


                //                if (mask_pixel == 0 ) {
                //                    image_pixel = qRgba(0,0,200,255);
                //                    result.setPixel(x,y,image_pixel);
                //                }

                result.setPixel(x,y,image_pixel);
            }
        }
        */
        *size = targetImage.size();

        return targetImage;
    }

    qDebug() << "isNull";

    return QImage();
}

